Package org.apache.commons.imaging.formats.webp.chunks

# Class AbstractWebPChunk

java.lang.Object
org.apache.commons.imaging.common.BinaryFileParser
org.apache.commons.imaging.formats.webp.chunks.AbstractWebPChunk

Direct Known Subclasses:
  `WebPChunkAlph`, `WebPChunkAnim`, `WebPChunkAnmf`, `WebPChunkExif`, `WebPChunkIccp`, `WebPChunkVp8`, `WebPChunkVp8l`, `WebPChunkVp8x`, `WebPChunkXml`, `WebPChunkXyzw`

public abstract class AbstractWebPChunk extends BinaryFileParser
A WebP image is composed of several chunks. This is the base class for the chunks, used by the parser.

Since:
  1.0.0-alpha4
See Also:
  - WebP Container Specification

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final byte[]`
  `bytes`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractWebPChunk(int type, int size, byte[] bytes)`
  Create a new WebP chunk.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `dump(PrintWriter pw, int offset)`
  Print the chunk to the given stream.
  `byte[]`
  `getBytes()`
  `int`
  `getChunkSize()`
  `int`
  `getPayloadSize()`
  `int`
  `getType()`
  `String`
  `getTypeDescription()`

  ### Methods inherited from class org.apache.commons.imaging.common.BinaryFileParser

  `debugNumber, debugNumber, getByteOrder, setByteOrder`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### bytes

    protected final byte[] bytes

- ## Constructor Details

  - ### AbstractWebPChunk

    public AbstractWebPChunk(int type, int size, byte[] bytes) throws ImagingException
    Create a new WebP chunk.
    Parameters:
      `type` - chunk type.
      `size` - chunk size.
      `bytes` - chunk data.
    Throws:
      `ImagingException` - if the chunk data and the size provided do not match.

- ## Method Details

  - ### dump

    public void dump(PrintWriter pw, int offset) throws ImagingException, IOException
    Print the chunk to the given stream.
    Parameters:
      `pw` - a stream to write to.
      `offset` - chunk offset.
    Throws:
      `ImagingException` - if the image is invalid.
      `IOException` - if it fails to write to the given stream.

  - ### getBytes

    public byte[] getBytes()
    Returns:
      a copy of the chunk data as bytes.

  - ### getChunkSize

    public int getChunkSize()
    Returns:
      the chunk size.

  - ### getPayloadSize

    public int getPayloadSize()
    Returns:
      the payload size.

  - ### getType

    public int getType()
    Returns:
      the chunk type.

  - ### getTypeDescription

    public String getTypeDescription()
    Returns:
      the description of the chunk type.